export declare type Listener<Event> = (event: Event) => void;
export declare type EventName<Events> = keyof Events;
export declare type ListenerCache<Events> = {
    [Name in keyof Events]?: Listener<Events[Name]>[];
};
export default class EventSystem<Events extends Record<string, any>> {
    private listeners;
    subscribe<T extends EventName<Events>>(eventname: T, listener: Listener<Events[T]>): void;
    unsubscribe<T extends EventName<Events>>(eventname: T, listener: Listener<Events[T]>): void;
    dispatch<T extends EventName<Events>>(eventname: T, event: Events[T]): void;
    clone(): EventSystem<Events>;
}
